#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long int n, q;
    cin >> n;
    cin >> q;
    long long int** x = new long long int *[n];
    for (int i = 0; i < n; i++)
    {
        x[i] = new long long int[2];
        long long int d, p;
        cin >> x[i][0];
        cin >> x[i][1];
    }

    for (int i1 = 0; i1 < q; i1++)
    {
        long long int k;
        cin >> k;
        long long int r = 0, p = 0;
        for (int i = 0; i < n; i++)
        {
            p += x[i][1];
            if (k < x[0][0])
            {
                r = 0;
                break;
            }
            if (i + 1 < n && k < x[i + 1][0])
            {
                if (k - x[i][0] < p)
                {
                    r += k - x[i][0] + 1;
                }
                else
                {
                    r += p;
                }
                break;
            }
            if (i + 1 == n)
            {
                if (k > x[i][0])
                {
                    if (k - x[i][0] < p)
                    {
                        r += k - x[i][0] + 1;
                    }
                    else
                    {
                        r += p;
                    }
                }
                else
                {
                    if (k - x[i - 1][0] < p)
                    {
                        r += k - x[i][0] + 1;
                    }
                    else
                    {
                        r += p;
                    }
                }
                break;
            }
            if (i + 1 < n && x[i + 1][0] - x[i][0] < p)
            {
                r += x[i + 1][0] - x[i][0];
                p -= x[i + 1][0] - x[i][0];
            }
            else
            {
                r += p;
                p = 0;
            }
        }

        cout << r << endl;
    }
}